case $CONFIG in
'')	 if test -r ../config.sh
	 then
	    . ../config.sh ;
	 else
	    spitshell=cat
	    package=IRC
	 fi
	 ;;
esac

echo "Extracting src/version.c..."

if test -r version.c
then
   generation=`sed -n 's/^char \*generation = \"\(.*\)\";/\1/p' < version.c`
   if test ! "$generation" ; then generation=0; fi
else
   generation=0
fi

generation=`expr $generation + 1`
creation=`date | \
awk '{if (NF == 6) \
         { print $1 " "  $2 " " $3 " "  $6 " at " $4 " " $5 } \
else \
         { print $1 " "  $2 " " $3 " " $7 " at " $4 " " $5 " " $6 }}'`

$spitshell >version.c <<!SUB!THIS!
/*
 *   HawkIRCd - Internet Relay Chat, ircd/version.c
 *   Copyright (C) 2001-2003 Francisco Antonello and
 *                           Elizandro Roos
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 1, or (at your option)
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   $Id: version.c.SH
 */

/*
 * This file is generated by version.c.SH. Any changes made will go away.
 */

#include "struct.h"
#include "version.h"
#include "license.h"

char *generation = "$generation";
char *creation = "$creation";
#define IRCDTOTALVERSION BASE_VERSION PATCH1 PATCH2 PATCH3 PATCH4 PATCH5 PATCH6 PATCH7 PATCH8 PATCH9
char *version = IRCDTOTALVERSION;

/* moved to s_serv.c */
char *infotext[] =
{ 0 };

char *opencrdits[] =
{
	"$package -- HawkIRCd",
	"-=-=-=-=-=-=-=-=-=-= [ " IRCDTOTALVERSION " Credits ] -=-=-=-=-=-",
	"* As pessoas nesta lista fazem parte ou ja fizeram parte da equipe",
	"* de desenvolvimento do HawkIRCd. A equipe do HawkIRCd agradece a",
	"* todos que contribuiram com este Projeto.",
	"-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-",
        "*",
	"*              \2\37HawkIRCd Coders Team\2\37",
	"*",
	"* Skyzer      ------- skyzer@canalsm.com.br",
	"* RPA         ------- rpa@canalsm.com.br",
	"*",
	"* Agradecemos a estas pessoas por seu empenho e grande ajuda",
	"* em versoes anteriores do HawkIRCd.",
	"*",
	"* ScOrP|On    ------- scorpion@underlinux.com.br",
	"* cym         ------- thomas@tcnet.com.br",
        "* Sparc       ------- sparc@vant.com.br",
	"*",
	"*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*",
	"* Type /Info to get more info",
        "*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*",

	0
};

char *ultimateinfotext[] =
{
	"-=-=-=-=-=-=-=-=-=-=-=-=-= [ Ultimate Credits ] -=-=-=-=-=-=-=-=-=-=-=-",
	"Parts of this IRCd code was taken from the",
	"UltimateIRCd Daemon Project @ http://sourceforge.net/projects/ultimate/",
	" ",
	"Thanks to:",
	"Thomas Juberg Stenss {shadowmaster}",
	"-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-",
	0
};

char *unrealinfotext[] =
{
	"-=-=-=-=-=-=-=-=-=-= [ Unreal Credits ] -=-=-=-=-",
	"The people on this list is people who have helped up through",
	"the development of UnrealIRCd. The Unreal Team would like to thank",
	"those people by listing them here:",
	"-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=",
	"              \2\37The UnrealIRCd Team would like to thank:\2\37",
	"Nutcais (Phil Hawkins)",
	"",
	"Mick and Sp^",
	"DrBin (Dave) drbin@tspre.org",
	"Headbang (Melle Visser)",
	"WonderWal (Alan Wolff)",
	"{X} (Laurie) x@tspre.org",
	"CC2IS Internet Services (http://www.cc2is.com)",
	"",
	"noriko noriko@linuxsquare.net",
	"llthangel",
	"",
	"                         \37Donations to Unreal:\37",
	"BlueFlame^",
	"[Real] from ChatFIRST.com",
	"",
	"              \37These people have helped alpha/betatesting\37",
	"zshack, Headbang, Mick, Sp^, WonderWal, bomb, BullFrog, JacobD,",
	"SirDeath, l33, EiniD, uo, RevPsych and the subgenius.net network,",
	"^RavenX^, Mich[a]el, {X}, Fish, Shmad, Killer, BrainSCAN, RevNull,",
	"GoNiS, Mikey, DrBin, rapta, crow, SevenEagle, Curt|s, Scooter,",
	"auspice, RaYmAn, Taz, HERZ, Pique, ROXnet, trinity, script0r",
	"BiGi, [ins4ne]",
	"",
        "                   \2\37Stskeeps would like to thank:\2\37",
	"Morrigan             Julie Frederiksen",
	"DJBoxy       *unknown*                *unknown*",
	"TC           Tabita Clausen           (reallife)",
	"M_Girly      Michelle Howie           *grin*",
        "SL7          Steve Lake               sl7 @ austnet.org",
	"Dark-Prince",
	"Sporty_McFly  Cedric",
	"Del_Monte     K. Hawkes               k.hawkes@zombies.force9.net",
	"Skywalker     Chris Morley            skywalker@irc.ru.ac.za",
	"*             Alexander Over          alexander@over.de",
	" - /botserv patch",
	"zero9000      Kevin Alford",
	" - UnrealIRCd logo, graphics, null desu ;), ideas etc.",
	"jfc           John Crowhurst",
	" - For us being able to use his wonder-box to code on and host CVS on",
	"HERZ",
	" - For proving me wrong in the beta phases....",
        "                   \2\37codemastr would like to thank:\2\37",
	"CaliMonk      Ivo Teel                calimonk@axenet.org",
	"[FBI]         Corey Lang              fbi@dal.net",
	"",
	"                            \2\37Also thanks to:\2\37",
	"Enforcer, Andy Church, Mick, Sp^, ShadowMastr, Almaris",
	"}{, Erik/Dr|zzt, Hedge, Kyle, MissKel, jfc, Fish, kore, Syndicate, Bagge,",
	"#Coder-Com@Undernet, ^NeVeR^, flygirl^, DannyM, JuliuZ, wah-wah^, Lisa,",
	"Melisa, Dukemaster, NonMortal, Andryan, TomaHawk, Lushes, Skywalker, Merlin, Sporty_McFly,",
	"zero9000, #wIRCd@DALnet, comstud, dog3, Dianora, Isomer, and others who arent listed here:)",
	"",
	"           *** End of Unreal Credits ***",
	" ",
	0
};

char ircdlogo[] = {
32,95,32,32,32,95,32,32,32,32,32,32,32,
32,32,32,32,32,32,32,32,32,95,32,32,32,
32,95,95,95,32,95,95,95,95,32,32,32,95,
95,95,95,32,32,32,32,95,10,124,32,124,
32,124,32,124,32,95,95,32,95,95,95,32,
32,32,32,32,32,95,124,32,124,32,95,124,
95,32,95,124,32,32,95,32,92,32,47,32,95,
95,95,124,95,95,124,32,124,10,124,32,
124,95,124,32,124,47,32,95,96,32,92,32,
92,32,47,92,32,47,32,47,32,124,47,32,
47,124,32,124,124,32,124,95,41,32,124,
32,124,32,32,32,47,32,95,32,32,124,10,
124,32,32,95,32,32,124,32,40,95,124,32,
124,92,32,86,32,32,86,32,47,124,32,32,
32,60,32,124,32,124,124,32,32,95,32,
60,124,32,124,95,95,124,32,40,95,124,32,
124,10,124,95,124,32,124,95,124,92,95,
95,44,95,124,32,92,95,47,92,95,47,92,
124,95,124,92,95,92,95,95,95,124,95,124,
32,92,95,92,92,95,95,95,95,92,95,95,44,
95,124,10,32,32,32,32,32,32,32,32,32,32,
32,32,32,32,32,32,32,32,32,32,32,32,32,
32,32,32,32,32,32,32,32,32,32,32,32,32,
32,32,32,32,32,32,32,0
};

char *dalinfotext[] =
    {
        "$package --",
        "Based on the original code written by Jarkko Oikarinen",
        "Copyright 1988, 1989, 1990, 1991 University of Oulu, Computing Center",
        " ",
        "This program is free software; you can redistribute it and/or",
        "modify it under the terms of the GNU General Public License as",
        "published by the Free Software Foundation; either version 1, or",
        "(at your option) any later version.",
	"- Any name/comment should never be changed except by the one who made it -",
	" ",
	"-- HawkIRCd contains code developed by:",
	" ",
	"Skyzer       Francisco Antonello      skyzer@canalsm.com.br",
	"Sparc        Elizandro Roos           sparc@vant.com.br",
	"RPA          Renato de Azevedo        rpa@@canalsm.com.br",
	" ",
	"The following people have helped in making the DALnet ircd",
        "that is based on irc2.8.21.mu3.2 :",
        " ",
        "Russell      Russell Miller           russell@dal.net",
        "Donwulff     Jukka Santala            donwulff@dal.net",
        "Aetobatus    Michael Sawyer           aetobatus@dal.net",
        "Dalvenjah    Sven Nielsen             dalvenjah@dal.net",
        "Skandranon   Michael Graff            explorer@flame.org",
        "Barubary     -                        barubary@dal.net",
        "white_dragon Chip Norkus              wd@dal.net",
        "DuffJ        Dafydd James             duffj@dal.net",
        "taz          David Kopstain           taz@dal.net",
        "NikB         Nik Bougalis             nikb@dal.net",
        "Rakarra      -                        rakarra@dal.net",
        "DarkRot      Lucas Madar              darkrot@dal.net",
        "Studded      -                        studded@dal.net",
        "JoelKatz     David Schwartz           joelkatz@dal.net",
        " ",
        "This product includes software developed by Colin Plumb.",
        " ",
        "The following persons have made many changes and enhancements to the",
        "code and still know how IRC really works if you have questions about it:",
        " ",
        "Run          Carlo Kid                carlo@runaway.xs4all.nl",
        "Avalon       Darren Reed              avalon@coombs.anu.edu.au",
        "msa          Markku Savela            Markku.Savela@vtt.fi",
        "Wumpus       Greg Lindahl             gl8f@virginia.edu",
        "WiZ          Jarkko Oikarinen         jto@tolsun.oulu.fi",
        "Argv         Armin Gruner Armin.Gruner@Informatik.TU-Muenchen.de",
        " ",
        "Thanks to the following people for help with preparing 2.8",
        " ",
        "phone        Matthew Green            phone@coombs.anu.edu.au",
        "Sodapop      Chuck Kane               ckane@ece.uiuc.edu",
        "Skygod       Matt Lyle                matt@oc.com",
        "Vesa         Vesa Ruokonen            ruokonen@lut.fi",
        "Nap          Nicolas PIOCH pioch@poly.polytechnique.fr",
        " ",
        "Those who helped in prior versions and continue to be helpful:",
        " ",
        "Stellan Klebom      Dan Goodwin         Mike Bolotski",
        "Ian Frechette       Markku Jarvinen     Kimmo Suominen",
        "Jeff Trim           Vijay Subramaniam   Karl Kleinpaste",
        "Bill Wisner         Tom Davis           Hugo Calendar",
        "Tom Hopkins         Stephen van den Berg",
        "Bo Adler            Michael Sandrof     Jon Solomon",
        "Jan Peterson        Helen Rose          Paul Graham",
        " ",
        "Thanks also goes to those persons not mentioned here who have added",
        "their advice, opinions, and code to IRC.",
        "Thanks also to those who provide the kind sys admins who let me and",
        "others continue to develop IRC.",
        " ",
        0
    };

char *halfopstext[] =
{
        "==================== Halfops (%) =====================",
        " ",
        "This is for user's that don't understand what",
        "half-op(s) % are.",
        " ",
        "Half-ops(%) are exactly what it mean's. Between",
        "a normal user that has no channel access and",
        "the channel operator(@).",
        " ",
        "% can not ban/kick @ or other % BUT they can ban/kick",
        "normal and auto-voiced(+v) user's.",
        "They can also change the channel topic and mode's",
        "and user's to the auto-voice list (vop).",
        " ",
	0
};
!SUB!THIS!
